Index: tmp/org.txm.core/src/java/org/txm/importer/CopyXMLFiles.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/CopyXMLFiles.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/CopyXMLFiles.groovy	(revision 881)
@@ -0,0 +1,61 @@
+package org.txm.importer;
+
+import java.io.File;
+import java.io.InputStream;
+
+import javax.xml.stream.XMLInputFactory;
+import javax.xml.stream.XMLResolver;
+import javax.xml.stream.XMLStreamConstants;
+import javax.xml.stream.XMLStreamException;
+import javax.xml.stream.XMLStreamReader;
+import javax.xml.stream.events.DTD;
+import javax.xml.stream.events.EntityReference;
+import org.txm.utils.*
+
+public class CopyXMLFiles {
+	File xmlFile;
+	File outDir;
+	def dtdFiles = []
+	
+	public CopyXMLFiles(File xmlFile) {
+		this.xmlFile = xmlFile;
+	}
+	
+	public boolean copy(File outDir) {
+		XMLInputFactory factory;
+		XMLStreamReader parser;
+		InputStream inputData = xmlFile.toURI().toURL().openStream();
+		factory = XMLInputFactory.newInstance();
+		factory.setXMLResolver(new XMLResolver() {
+			@Override
+			public Object resolveEntity(String publicID, String systemID,
+					String baseURI, String namespace) throws XMLStreamException {
+				//println "Resolving $publicID $systemID $baseURI $namespace"
+				File srcFile = new File(xmlFile.getParentFile(), systemID);
+				dtdFiles << srcFile
+				return srcFile.toURI().toURL().openStream();
+			}
+		});
+	
+		parser = factory.createXMLStreamReader(inputData);
+		
+		for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) {
+			
+		}
+		
+		dtdFiles << xmlFile
+		for (File dtd : dtdFiles) {
+			File cpy = new File(outDir, dtd.getName());
+			FileCopy.copy(dtd, cpy);
+		}
+		return outDir.listFiles().size() == dtdFiles.size();
+	}
+	
+	public static void main(def args) {
+		File xmlFile = new File("/home/mdecorde/Téléchargements/Inscriptions1.xml")
+		File outDir = new File("/home/mdecorde/Téléchargements/test")
+		outDir.mkdir()
+		CopyXMLFiles cdf = new CopyXMLFiles(xmlFile)
+		println cdf.copy(outDir)
+	}
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/FortranColumns2XML.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/FortranColumns2XML.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/FortranColumns2XML.groovy	(revision 881)
@@ -0,0 +1,325 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+
+//
+// This file is part of the TXM platform.
+//
+// The TXM platform is free software: you can redistribute it and/or modif y
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// The TXM platform is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with the TXM platform.  If not, see <http://www.gnu.org/licenses/>.
+// 
+// 
+// 
+// $LastChangedDate: 2017-04-11 15:30:35 +0200 (mar. 11 avril 2017) $
+// $LastChangedRevision: 3426 $
+// $LastChangedBy: mdecorde $ 
+//
+package org.txm.importer;
+
+import org.txm.utils.i18n.DetectBOM;
+import org.w3c.dom.Document;
+import org.w3c.dom.Element;
+import org.w3c.dom.NodeList;
+import org.xml.sax.SAXException;
+
+import java.io.File;
+import java.io.FileInputStream;
+import java.io.InputStreamReader;
+
+import javax.xml.stream.*;
+import java.net.URL;
+
+// TODO: Auto-generated Javadoc
+/**
+ * The Class FortranColumns2XML.
+ */
+class FortranColumns2XML {
+	
+	/** The infile. */
+	
+	File infile;
+	
+	/** The outfile. */
+	File outfile;
+	
+	/** The encoding. */
+	String encoding;
+	
+	/** The column names. */
+	List<String> columnNames
+	
+	/** The word tag. */
+	String wordTag;
+	
+	/** The wordcolumn. */
+	int wordcolumn;
+	
+	/** The linecounter. */
+	int linecounter = 0;
+	
+	/** The check line number. */
+	int checkLineNumber;
+	
+	/** The check line number tag. */
+	String checkLineNumberTag;
+	
+	/** The columnindex. */
+	private List<Integer> columnindex;
+	
+	/** The endcolumnindex. */
+	private List<Integer> endcolumnindex;
+	
+	/** The line. */
+	private String line;
+	
+	/** The writer. */
+	private XMLStreamWriter writer;
+	
+	/** The reader. */
+	private Reader reader;
+	
+	/** The output. */
+	private FileOutputStream output;
+	
+	String textname;
+	
+	/**
+	 * Instantiates a new fortran columns2 xml.
+	 *
+	 * @param infile the infile
+	 * @param outfile the outfile
+	 * @param encoding the encoding
+	 */
+	FortranColumns2XML(File infile, File outfile, String encoding)
+	{
+		this.infile = infile;
+		this.outfile = outfile;
+		
+		textname = infile.getName();
+		int idx = -1;
+		idx = textname.lastIndexOf(".");
+		if (idx > 0)
+			textname = textname.substring(0, idx);
+
+		def input = new FileInputStream(infile) 		
+		reader = new InputStreamReader(input , encoding);
+		DetectBOM bomdetector = new DetectBOM(infile);
+		for (int ibom = 0 ; ibom < bomdetector.getBOMSize() ; ibom++) input.read()
+		
+		XMLOutputFactory factory = XMLOutputFactory.newInstance();
+		output = new FileOutputStream(outfile)
+		writer = factory.createXMLStreamWriter(output, "UTF-8");
+	}
+	
+	/**
+	 * Process.
+	 *
+	 * @return true, if successful
+	 */
+	public boolean process()
+	{
+		line = reader.readLine(); // use the first line to find columns 
+		
+		if(columnindex == null || endcolumnindex == null)
+		{
+			searchNumberOfColumns();
+		}
+		
+		if(columnindex.size() != columnNames.size())
+		{
+			System.err.println("Number of column("+columnindex.size()+") different of number of column name("+columnNames.size()+")");
+			return false;
+		}
+		
+		//write start document
+		writer.writeStartDocument("UTF-8", "1.0");
+		writer.writeStartElement("text")
+		writer.writeAttribute("id",infile.getName())
+		
+		boolean gogogo = true;
+		while(gogogo)
+		{	
+			//println "line : "+line
+			processLine();//split line accordinly to columnindexes
+			linecounter++;
+			
+			//continue to read the document
+			line = reader.readLine();
+			if(line == null)
+				gogogo= false;
+		}
+		
+		writer.writeEndElement();
+		writer.writeEndDocument();
+		writer.close();
+		output.close();
+		
+		return true;
+	}
+	
+	/**
+	 * Process line.
+	 */
+	int wordcount = 1;
+	private void processLine()
+	{
+		String pcdata;
+		if(line.length() > 0)
+		{
+			writer.writeStartElement(wordTag)
+			if(setIds)
+				writer.writeAttribute("id", "w_"+textname+"_"+(wordcount++));
+			for(int i = 0 ; i < columnindex.size(); i++)
+			{
+				if(line.length() > endcolumnindex.get(i))
+				{
+					String substring = line.substring(columnindex.get(i), endcolumnindex.get(i))
+					if(i != wordcolumn)
+					{
+						writer.writeAttribute(columnNames.get(i), substring.trim())
+					}
+					else
+					{
+						pcdata = substring.trim()
+					}
+				}
+				else
+				{
+					println "Error: line $linecounter: len="+line.length()+" maxidx="+endcolumnindex.get(i)
+					println line;
+				}
+			}
+			writer.writeCharacters(pcdata);
+			writer.writeEndElement();
+		}
+	}
+	
+	/**
+	 * Sets the column indexes.
+	 *
+	 * @param starts the starts
+	 * @param ends the ends
+	 */
+	private void setColumnIndexes(List<Integer> starts, List<Integer> ends)
+	{
+		columnindex = starts;
+		endcolumnindex = ends;
+	}
+	
+	boolean setIds = false;
+	public void setAddIds(boolean setIds)
+	{
+		this.setIds = setIds;
+	}
+	
+	/**
+	 * Search number of columns.
+	 */
+	private void searchNumberOfColumns()
+	{
+		columnindex = new ArrayList<Integer>();
+		endcolumnindex = new ArrayList<Integer>();
+		columnindex.add(0);
+		int ic = 0
+		char c;
+		char[] cline = line.toCharArray();
+		int state = 0; // 0 lettre, 1 espace
+		
+		for(ic = 0 ; ic < cline.length ; ic++)
+		{
+			c = cline[ic];
+			if(state == 0)// zone lettre
+			{
+				if(c == " ")
+				{
+					state = 1;
+					
+				}
+			}
+			else // zone espace
+			{
+				if(c != " ")
+				{
+					columnindex.add(ic);
+					endcolumnindex.add(ic-1);
+					state = 0;
+				}
+			}
+		}
+		endcolumnindex.add(cline.length);
+		println columnindex;
+		println endcolumnindex;
+	}
+	
+	/**
+	 * Sets the columns lines names.
+	 *
+	 * @param columnNames the column names
+	 * @param unitTag the unit tag
+	 * @param wordcolumn the wordcolumn
+	 */
+	public void setColumnsLinesNames(List<String> columnNames, String unitTag, int wordcolumn)
+	{
+		this.columnNames = columnNames;
+		this.wordTag = unitTag;
+		this.wordcolumn = wordcolumn;
+	}
+	
+	/**
+	 * Sets the line check.
+	 *
+	 * @param colindex the colindex
+	 * @param tagname the tagname
+	 */
+	public void setLineCheck(int colindex, String tagname)
+	{
+		this.checkLineNumber = colindex;
+		this.checkLineNumberTag = tagname;
+	}
+	
+	/**
+	 * The main method.
+	 *
+	 * @param args the arguments
+	 */
+	public static void main(String[] args)
+	{
+		File fortranfile = new File(System.getProperty("user.home"),"\\xml\\lasla\\lasla\\L01PlaAmphi.APN");
+		File outfile = new File(System.getProperty("user.home"),"\\xml\\lasla\\out.xml");
+		FortranColumns2XML builder = new FortranColumns2XML(fortranfile, outfile, "iso-8859-1");
+		builder.setColumnIndexes([0, 3, 4, 8, 29, 55, 67],	[3, 4, 8, 28, 54, 66, 79]);
+		builder.setColumnsLinesNames(["ref","s","sent","word","lemme","line","pos"], "w", 3);
+		builder.setLineCheck(3, "l");
+		
+		builder.process();
+	}
+}
+
+
Index: tmp/org.txm.core/src/java/org/txm/importer/CsvToXml.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/CsvToXml.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/CsvToXml.groovy	(revision 881)
@@ -0,0 +1,185 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+//
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+//
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+//
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+//
+//
+//
+// $LastChangedDate: 2015-12-17 12:11:39 +0100 (jeu. 17 déc. 2015) $
+// $LastChangedRevision: 3087 $
+// $LastChangedBy: mdecorde $
+//
+package org.txm.importer
+
+import java.io.FileInputStream
+import java.io.InputStreamReader
+import java.nio.charset.Charset
+import org.txm.utils.*
+
+import javax.xml.stream.*
+import java.net.URL
+
+/**
+ * The Class CsvToXml: allow to convert CSV files to XML files
+ *
+ * @author mdecorde
+ */
+class CsvToXml {
+
+	/** The titles. */
+	File xmlfile
+	List<String> titles = []
+
+	private CsvReader getCSVReader(File csvfile, String fieldSeparator, String encoding) {
+		CsvReader csvreader = new CsvReader(csvfile.getAbsolutePath(), fieldSeparator.charAt(0), Charset.forName(encoding))
+
+		//get titles
+		csvreader.readHeaders()
+		titles = []
+		for (String title : csvreader.getHeaders()) {
+			titles << title
+		}
+
+		if (titles.size() == 0) {
+			println "the CSV file as no column"
+			return null
+		}
+
+		if (titles.contains("text") == 0) {
+			println "the CSV file as no 'text' column"
+			return null
+		}
+
+		if (titles.contains("id") == 0) {
+			println "the CSV file as no 'id' column"
+			return null
+		}
+		
+		return csvreader
+	}
+	
+	/**
+	 * Convert a CSV file to ONE XML file using the first line to declare metadata
+	 *
+	 * @param csvfile the csvfile
+	 * @param outfile the outfile
+	 * @param fieldSeparator the field separator
+	 * @param textSeparator the text separator
+	 * @param encoding the encoding
+	 * @return true, if successful
+	 */
+	public boolean toOneXMLFile(File csvfile, File xmlfile, String fieldSeparator, String textSeparator, String encoding) {
+		CsvReader csvreader = getCSVReader(csvfile, fieldSeparator, encoding)
+		if (csvreader == null) return false
+		
+		println "Metadata properties declared: "+titles
+
+		XMLOutputFactory factory = XMLOutputFactory.newInstance()
+		FileOutputStream output = new FileOutputStream(xmlfile)
+		XMLStreamWriter writer = factory.createXMLStreamWriter(output, "UTF-8")
+
+		writer.writeStartDocument("UTF-8","1.0")
+		writer.writeStartElement("text")
+		while (csvreader.readRecord()) {
+			
+			writer.writeStartElement("div")
+
+			for (int i = 0 ; i < titles.size() ; i++) {
+				if (titles[i] == "text") continue
+				writer.writeAttribute(AsciiUtils.buildId(titles.get(i)), csvreader.get(i))
+			}
+
+			writer.writeCharacters(csvreader.get("text")) // get text content
+			writer.writeEndElement() // div
+		}
+
+		writer.writeEndElement() // text
+		writer.close()
+		output.close()
+		csvreader.close()
+
+		return true;
+	}
+	
+	/**
+	* Convert a CSV file to SEVERAL XML file using the first line to declare metadata
+	*
+	* @param csvfile the csvfile
+	* @param outfile the outfile
+	* @param fieldSeparator the field separator
+	* @param textSeparator the text separator
+	* @param encoding the encoding
+	* @return true, if successful
+	*/
+	public boolean toMultipleXMLFiles(File csvfile, File outDir, String fieldSeparator, String textSeparator, String encoding) {
+		CsvReader csvreader = getCSVReader(csvfile, fieldSeparator, encoding)
+		if (csvreader == null) return false
+		
+		if (!outDir.exists()) outDir.mkdirs()
+		if (!outDir.exists()) {
+			println "Out directory does not exist and could not create it"
+			return false;
+		}
+		
+		while (csvreader.readRecord()) {
+			
+			File xmlfile = new File(outDir, csvreader.get("id")+".xml")
+			
+			XMLOutputFactory factory = XMLOutputFactory.newInstance()
+			FileOutputStream output = new FileOutputStream(xmlfile)
+			XMLStreamWriter writer = factory.createXMLStreamWriter(output, "UTF-8")
+	
+			writer.writeStartDocument("UTF-8","1.0")
+			writer.writeStartElement("text")
+			
+			for (int i = 0 ; i < titles.size() ; i++) {
+				if (titles[i] == "text") continue
+				writer.writeAttribute(AsciiUtils.buildId(titles.get(i)), csvreader.get(i))
+			}
+
+			writer.writeCharacters(csvreader.get("text")) // get text content
+			
+			writer.writeEndElement() //text
+			writer.close()
+			output.close()
+		}
+		return true
+	}
+
+	/**
+	 * The main method.
+	 *
+	 * @param args the arguments
+	 */
+	static public void main(String[] args)
+	{
+		String home = System.getProperty("user.home")
+		File csvfile = new File(home, "xml/csv/test.csv")
+		File outfile = new File(home, "xml/csv/test.xml")
+		File outdir = new File(home, "xml/csv/out")
+
+		String fieldSeparator = "\t"
+		String textSeparator = "" //or "'"
+		CsvToXml builder = new CsvToXml()
+		
+		builder.toMultipleXMLFiles(csvfile, outdir, fieldSeparator, textSeparator, "UTF-8")
+		
+		builder.toOneXMLFile(csvfile, outfile, fieldSeparator, textSeparator, "UTF-8")
+	}
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/SAttributesListener.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/SAttributesListener.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/SAttributesListener.groovy	(revision 881)
@@ -0,0 +1,217 @@
+package org.txm.importer
+
+import java.util.ArrayList;
+import java.util.HashMap;
+
+import javax.xml.stream.*;
+
+/**
+ * Read an XML file and find out : XML elements, their attributes and recursivity level
+ * names are lowercases
+ * 
+ * @author mdecorde
+ *
+ */
+class SAttributesListener {
+
+	private static HashMap<String,ArrayList<String>> structs = new HashMap<String, ArrayList<String>>();
+	private static HashMap<String, Integer> structsCountProf = new HashMap<String, Integer>();
+	private static HashMap<String, Integer> structsMaxProf = new HashMap<String, Integer>();
+	private static String structPath = "/";
+	private XMLStreamReader parser;
+
+	SAttributesListener() {
+		structs = new HashMap<String, ArrayList<String>>();
+		structsCountProf = new HashMap<String, Integer>();
+		structsMaxProf = new HashMap<String, Integer>();
+		structPath = "/";
+	}
+	
+	SAttributesListener(XMLStreamReader parser) {
+		this();
+		this.parser = parser;
+	}
+	
+	public void appendResultsTo(SAttributesListener another) {
+		structs = another.structs;
+		structsCountProf = another.structsCountProf;
+		structsMaxProf = another.structsMaxProf;
+	}
+
+	public void start(def parser) {
+		this.parser = parser;
+	}
+
+	def W = "w";
+	def ANA = "ana";
+	def FORM = "form";
+	/**
+	 * Call this method for each START_ELEMENT stax event
+	 * @param localname the element localname
+	 */
+	public void startElement(String localname) {
+		localname = localname.toLowerCase();
+
+		//String localname = parser.getLocalName();
+		if(localname.equals(W)) return;
+		if(localname.equals(ANA)) return;
+		if(localname.equals(FORM)) return;
+
+		structPath += localname+"/"
+		//println "add: "+structPath
+		def attrs = structs.get(localname)
+		if (!structs.containsKey(localname)) {
+			attrs = new HashSet();
+			structs.put(localname, attrs);
+			structsCountProf.put(localname, 0)
+			structsMaxProf.put(localname, 0)
+		} //else {
+		
+		// get structure recursion
+		int prof = structsCountProf.get(localname)+1
+		structsCountProf.put(localname, prof)
+		if (structsMaxProf.get(localname) < prof )
+			structsMaxProf.put(localname, prof)
+		
+		// get the structure attributes
+		for (int i = 0 ; i < parser.getAttributeCount() ; i++) {
+			attrs << parser.getAttributeLocalName(i).toLowerCase();
+		}
+	}
+
+	/**
+	 * Call this method for each END_ELEMENT stax event
+	 * @param localname the element localname
+	 */
+	public void endElement(String localname) {
+		localname = localname.toLowerCase();
+		//String localname = parser.getLocalName();
+		if(localname.equals(W)) return;
+		if(localname.equals(ANA)) return;
+		if(localname.equals(FORM)) return;
+
+		if (structPath.length() > 1) {
+			int idx = structPath.lastIndexOf("/");
+			if (idx > 0) {
+				structPath = structPath.substring(0, idx)
+				//println "end of $localname "+(structsCountProf.get(localname))
+				//if (structsCountProf.get(localname) != null)
+				structsCountProf.put(localname, structsCountProf.get(localname)-1)
+			}
+			//println "pop: "+structPath
+		}
+	}
+
+	boolean firstGetStructs = true;
+	public HashMap<String,ArrayList<String>> getStructs() {
+		if (structsCountProf.get("div") > 0)
+			structs.remove("div1")
+		if (structsCountProf.get("div") > 1)
+			structs.remove("div2")
+		if (structsCountProf.get("div") > 2)
+			structs.remove("div3")
+		if (structsCountProf.get("div") > 3)
+			structs.remove("div4")
+		if (structsCountProf.get("div") > 4)
+			structs.remove("div5")
+		if (structsCountProf.get("div") > 5)
+			structs.remove("div6")
+
+		if (firstGetStructs) {
+			firstGetStructs = false;
+			def keys = []
+			keys.addAll(structs.keySet());
+			for( String key : keys) {
+				def value = structs.get(key);
+				structs.remove(key)
+				structs.put(key.toLowerCase(), value);
+			}
+		}
+
+		return structs;
+	}
+
+	boolean firstGetstructsCountProf = true;
+	public HashMap<String, Integer> getProfs() {
+
+		//		if (firstGetstructsCountProf) {
+		//			firstGetstructsCountProf = false;
+		//			def keys = []
+		//			keys.addAll(structsCountProf.keySet());
+		//			for( String key : keys) {
+		//				def value = structsCountProf.get(key);
+		//				structsCountProf.remove(key)
+		//				structsCountProf.put(key.toLowerCase(), value);
+		//			}
+		//		}
+		HashMap<String, Integer> clone = new HashMap<String, Integer>();
+		for (String key : structsMaxProf.keySet()) {
+			if (structsMaxProf.get(key) > 0)
+				clone.put(key, structsMaxProf.get(key)-1)
+			else
+				clone.put(key, 0)
+		}
+		return clone;
+	}
+	
+	public static SAttributesListener scanFile(File xmlFile) {
+		return scanFile(xmlFile, null)
+	}
+	
+	public void setParser(def parser) {
+		this.parser = parser;
+	}
+	
+	/**
+	 * Merge results in the parentListener
+	 * 
+	 * @param xmlFile
+	 * @param parentListener results are appended to the parentListener if any
+	 * @return
+	 */
+	public static SAttributesListener scanFile(File xmlFile, SAttributesListener parentListener) {
+		
+		def start = false;
+		def inputData = xmlFile.toURI().toURL().openStream();
+		def factory = XMLInputFactory.newInstance();
+		def parser = factory.createXMLStreamReader(inputData);
+		
+		SAttributesListener listener;
+		if (parentListener != null) {
+			listener = parentListener;
+			listener.setParser(parser)
+		} else {
+			listener = new SAttributesListener(parser);
+		}
+		String TEXT = "text";
+		//HashSet<String> types = new HashSet<String>();
+		for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) {
+			if (event == XMLStreamConstants.START_ELEMENT) { // start elem
+				if (TEXT.equals(parser.getLocalName())) start = true;
+				if (start) listener.startElement(parser.getLocalName())
+			} else if (event == XMLStreamConstants.END_ELEMENT) { // end elem
+				if (start) listener.endElement(parser.getLocalName())
+				if (TEXT.equals(parser.getLocalName())) start = false;
+			}
+		}
+		parser.close()
+		
+		return listener
+	}
+	
+	public static SAttributesListener scanFiles(File xmlDirectory, String wordTag) {
+		SAttributesListener listener = new SAttributesListener()
+		listener.W = wordTag
+		for (File xmlFile : xmlDirectory.listFiles()) {
+			if (xmlFile.isFile() && !xmlFile.isHidden() && xmlFile.getName().toLowerCase().endsWith(".xml")) {
+				scanFile(xmlFile, listener); // results saved in 'listener' data
+//				println "LISTENER RESULT with ${xmlFile.getName()}: "+listener
+//				println " prof: "+listener.getStructs()
+//				println " prof: "+listener.getProfs()
+//				println " path: "+listener.structPath
+			}
+		}
+		
+		return listener;
+	}
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/CleanFile.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/CleanFile.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/CleanFile.groovy	(revision 881)
@@ -0,0 +1,135 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+
+//
+// This file is part of the TXM platform.
+//
+// The TXM platform is free software: you can redistribute it and/or modif y
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// The TXM platform is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with the TXM platform.  If not, see <http://www.gnu.org/licenses/>.
+// 
+// 
+// 
+// $LastChangedDate: 2017-06-26 16:53:47 +0200 (lun. 26 juin 2017) $
+// $LastChangedRevision: 3451 $
+// $LastChangedBy: mdecorde $ 
+//
+package org.txm.importer;
+
+import java.io.BufferedWriter;
+import java.io.File;
+
+import javax.xml.stream.XMLInputFactory;
+import javax.xml.stream.XMLStreamReader
+
+import org.txm.utils.io.IOUtils;
+
+// TODO: Auto-generated Javadoc
+/**
+ * remove all ctrl char and replace \t by ' '.
+ *
+ * @param infile : the file to process
+ * @param encoding : the encoding of the file
+ */
+class CleanFile {
+	public CleanFile(File infile, String encoding){
+		Reader reader = new BufferedReader(new InputStreamReader(new FileInputStream(infile),encoding));
+		File outfile = File.createTempFile("filecleaner","123456", infile.getParentFile());
+		Writer writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outfile), "UTF-8"));
+		String line = reader.readLine();
+		while(line != null) {
+			writer.write(clean(line) +"\n")
+			line = reader.readLine();
+		}
+		writer.close();
+		reader.close();
+		
+		infile.delete(); // erase old file
+		outfile.renameTo(infile); // rename the copy
+	}
+
+	def static ctrl_reg = /[\p{Cntrl}&&[^\n\t]]/ // all ctrl but \n
+	
+	def static surrogate = "[^\\p{P}&&[^\\u0001-\\uFFFF]]"
+	def static surrogate_reg = /$surrogate/
+	def static surrogate_punct = "[\\p{P}&&[^\\u0001-\\uFFFF]]"
+	def static surrogate_punct_reg = /$surrogate_punct/
+	def static SURROGATE = "_"
+	def static SURROGATE_PUNCT = "☒"
+	def static EMPTY = ""
+	def static SPACE = " "
+	def static TAB = "\t"
+	
+	/**
+	 * Remove ctrl and surrogates chars from a String. except tabs
+	 *
+	 * @param str the str
+	 * @return the cleaned string
+	 */
+	public static String cleanAllButTabs(String str) {
+		str = str.replaceAll(ctrl_reg, EMPTY); // remove all ctrl chars
+		str = str.replaceAll(surrogate_reg, SURROGATE); // replace all surrogate chars
+		str = str.replaceAll(surrogate_punct_reg, SURROGATE_PUNCT); // replace all surrogate punct chars
+		return str;
+	}
+	
+	/**
+	 * Remove ctrl and surrogates chars from a String.
+	 *
+	 * @param str the str
+	 * @return the cleaned string
+	 */
+	public static String clean(String str) {
+		str = str.replace(TAB, SPACE); // replace \t by ' '
+		str = str.replaceAll(ctrl_reg, EMPTY); // remove all ctrl chars
+		str = str.replaceAll(surrogate_reg, SURROGATE); // replace all surrogate chars
+		str = str.replaceAll(surrogate_punct_reg, SURROGATE_PUNCT); // replace all surrogate punct chars
+		return str;
+	}
+	
+	public static void removeSurrogateFromXmlFile(File file, File outputFile) {
+		XMLStreamReader xmlStreamReader = XMLInputFactory.newInstance().createXMLStreamReader( new FileReader( file ) );
+		String fileEncoding = xmlStreamReader.getEncoding();
+		String text = IOUtils.getText(file, fileEncoding)
+		text = CleanFile.clean(text);
+		IOUtils.write(outputFile, text)
+	}
+
+	/**
+	 * The main method.
+	 *
+	 * @param args the arguments
+	 */
+	public static void main(String[] args){
+		File infile = new File("C:\\Documents and Settings\\H\\xml\\cleaner\\test.txt")		
+		String encoding = "CP1252";
+		new CleanFile(infile, encoding);
+	}
+}
